declare interface Stats {
  passed: number
  failed: number
  skipped: number
}

declare class Eltro {
  __timeout: number
  hasExclusive: boolean
  reporter: 'dot' | 'list'
  Eltro: Eltro
  fileGroupMap: Map<string, Group>
  groups: Array<Group>
  activeGroup: Group | null
  failedTests: Array<Test>
  hasTests: boolean
  starting: boolean
  ignoreOnly: boolean
  logger: null | { log: function(...param): void }
  filename: string
  prefix: string
  temporary: { timeout: number, skip: boolean, only: boolean }
  describeTemporary: { timeout: number, skip: boolean, only: boolean }

  __runTest(stats: Stats, test: Test, prefix: string = 'Test', child?: Test | null = null)
  __runGroup(group: Group, stats: Stats)
  begin()
  run()
  setFilename(filename: string)
  resetFilename(filename: string)

  before(fn: (done?: Function) => void | Promise)
  after(fn: (done?: Function) => void | Promise)
  beforeEach(fn: (done?: Function) => void | Promise)
  afterEach(fn: (done?: Function) => void | Promise)
  describe(name: string, fn: Function)
}

declare class Test {

}

declare class Group {
  
}

export default new Eltro()